﻿Public Class Account
    Private m_Id As Long
    Private m_Balance As Double

    Public Event PropertyChange() 'ByVal aPropName As String, ByVal OldBalance As Double, ByVal CurBalance As Double)

    Public Sub New(ByVal aID As Long, Optional ByVal aBalance As Double = 0)
        m_Id = aID : m_Balance = aBalance
    End Sub

    Public ReadOnly Property Id() As Long
        Get
            Return m_Id
        End Get
    End Property

    Public ReadOnly Property Balance() As Double
        Get
            Return m_Balance
        End Get
    End Property

    Public Sub Deposit(ByVal Amount As Double)
        Dim OldBalance As Double = m_Balance
        m_Balance += Amount
        RaiseEvent PropertyChange()  '"Balance", OldBalance, m_Balance)
    End Sub

    Public Sub Withdraw(ByVal Amount As Double)
        'If Amount > m_Balance Then
        '    'throw new IllegalStateException("Insufficient Funds");
        '    'Err.Raise 1, "IllegalStateException", "IllegalStateException Insufficent Funds"
        '    MsgBox "IllegalStateException " & "Insufficent Funds"
        '    Exit Sub
        'End If
        Dim OldBalance As Double = m_Balance
        m_Balance -= Amount
        RaiseEvent PropertyChange()  '"Balance", OldBalance, m_Balance)
    End Sub

End Class
